/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-dynamic-tf-publisher-2.0.3-0precise-20150728-0056/srv/SetDynamicTF.srv
 *
 */


#ifndef DYNAMIC_TF_PUBLISHER_MESSAGE_SETDYNAMICTFREQUEST_H
#define DYNAMIC_TF_PUBLISHER_MESSAGE_SETDYNAMICTFREQUEST_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <geometry_msgs/TransformStamped.h>

namespace dynamic_tf_publisher
{
template <class ContainerAllocator>
struct SetDynamicTFRequest_
{
  typedef SetDynamicTFRequest_<ContainerAllocator> Type;

  SetDynamicTFRequest_()
    : freq(0.0)
    , cur_tf()  {
    }
  SetDynamicTFRequest_(const ContainerAllocator& _alloc)
    : freq(0.0)
    , cur_tf(_alloc)  {
    }



   typedef float _freq_type;
  _freq_type freq;

   typedef  ::geometry_msgs::TransformStamped_<ContainerAllocator>  _cur_tf_type;
  _cur_tf_type cur_tf;




  typedef boost::shared_ptr< ::dynamic_tf_publisher::SetDynamicTFRequest_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::dynamic_tf_publisher::SetDynamicTFRequest_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct SetDynamicTFRequest_

typedef ::dynamic_tf_publisher::SetDynamicTFRequest_<std::allocator<void> > SetDynamicTFRequest;

typedef boost::shared_ptr< ::dynamic_tf_publisher::SetDynamicTFRequest > SetDynamicTFRequestPtr;
typedef boost::shared_ptr< ::dynamic_tf_publisher::SetDynamicTFRequest const> SetDynamicTFRequestConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::dynamic_tf_publisher::SetDynamicTFRequest_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::dynamic_tf_publisher::SetDynamicTFRequest_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace dynamic_tf_publisher

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'geometry_msgs': ['/opt/ros/hydro/share/geometry_msgs/cmake/../msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::dynamic_tf_publisher::SetDynamicTFRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::dynamic_tf_publisher::SetDynamicTFRequest_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::dynamic_tf_publisher::SetDynamicTFRequest_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::dynamic_tf_publisher::SetDynamicTFRequest_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::dynamic_tf_publisher::SetDynamicTFRequest_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::dynamic_tf_publisher::SetDynamicTFRequest_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::dynamic_tf_publisher::SetDynamicTFRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "257be6eb2c49e846d6c3c12c85bb0fb1";
  }

  static const char* value(const ::dynamic_tf_publisher::SetDynamicTFRequest_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x257be6eb2c49e846ULL;
  static const uint64_t static_value2 = 0xd6c3c12c85bb0fb1ULL;
};

template<class ContainerAllocator>
struct DataType< ::dynamic_tf_publisher::SetDynamicTFRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "dynamic_tf_publisher/SetDynamicTFRequest";
  }

  static const char* value(const ::dynamic_tf_publisher::SetDynamicTFRequest_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::dynamic_tf_publisher::SetDynamicTFRequest_<ContainerAllocator> >
{
  static const char* value()
  {
    return "float32 freq\n\
geometry_msgs/TransformStamped cur_tf\n\
\n\
================================================================================\n\
MSG: geometry_msgs/TransformStamped\n\
# This expresses a transform from coordinate frame header.frame_id\n\
# to the coordinate frame child_frame_id\n\
#\n\
# This message is mostly used by the \n\
# <a href=\"http://www.ros.org/wiki/tf\">tf</a> package. \n\
# See its documentation for more information.\n\
\n\
Header header\n\
string child_frame_id # the frame id of the child frame\n\
Transform transform\n\
\n\
================================================================================\n\
MSG: std_msgs/Header\n\
# Standard metadata for higher-level stamped data types.\n\
# This is generally used to communicate timestamped data \n\
# in a particular coordinate frame.\n\
# \n\
# sequence ID: consecutively increasing ID \n\
uint32 seq\n\
#Two-integer timestamp that is expressed as:\n\
# * stamp.secs: seconds (stamp_secs) since epoch\n\
# * stamp.nsecs: nanoseconds since stamp_secs\n\
# time-handling sugar is provided by the client library\n\
time stamp\n\
#Frame this data is associated with\n\
# 0: no frame\n\
# 1: global frame\n\
string frame_id\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Transform\n\
# This represents the transform between two coordinate frames in free space.\n\
\n\
Vector3 translation\n\
Quaternion rotation\n\
\n\
================================================================================\n\
MSG: geometry_msgs/Vector3\n\
# This represents a vector in free space. \n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
================================================================================\n\
MSG: geometry_msgs/Quaternion\n\
# This represents an orientation in free space in quaternion form.\n\
\n\
float64 x\n\
float64 y\n\
float64 z\n\
float64 w\n\
";
  }

  static const char* value(const ::dynamic_tf_publisher::SetDynamicTFRequest_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::dynamic_tf_publisher::SetDynamicTFRequest_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.freq);
      stream.next(m.cur_tf);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct SetDynamicTFRequest_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::dynamic_tf_publisher::SetDynamicTFRequest_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::dynamic_tf_publisher::SetDynamicTFRequest_<ContainerAllocator>& v)
  {
    s << indent << "freq: ";
    Printer<float>::stream(s, indent + "  ", v.freq);
    s << indent << "cur_tf: ";
    s << std::endl;
    Printer< ::geometry_msgs::TransformStamped_<ContainerAllocator> >::stream(s, indent + "  ", v.cur_tf);
  }
};

} // namespace message_operations
} // namespace ros

#endif // DYNAMIC_TF_PUBLISHER_MESSAGE_SETDYNAMICTFREQUEST_H
